package cn.com.qmth.scancentral.service;

import java.util.List;

import com.baomidou.mybatisplus.extension.service.IService;

import cn.com.qmth.scancentral.bean.User;
import cn.com.qmth.scancentral.bean.answertask.StudentAnswerTaskSaveDomain;
import cn.com.qmth.scancentral.bean.answertask.StudentAnswerTaskSaveVo;
import cn.com.qmth.scancentral.bean.answertask.StudentAnswerTaskStatusVo;
import cn.com.qmth.scancentral.bean.answertask.StudentAnswerTaskVo;
import cn.com.qmth.scancentral.entity.StudentAnswerGroupEntity;
import cn.com.qmth.scancentral.entity.StudentAnswerTaskEntity;
import cn.com.qmth.scancentral.enums.StudentAnswerTaskStatus;

public interface StudentAnswerTaskService extends IService<StudentAnswerTaskEntity> {

    int getCountByExam(Long examId);

    int getCountByExamAndStatus(Long examId, StudentAnswerTaskStatus status);

    void deleteByGroupId(Long groupId);

    void resetByGroup(StudentAnswerGroupEntity group);

    StudentAnswerTaskVo getTask(Long examId, String account);

    StudentAnswerTaskSaveVo submitTask(StudentAnswerTaskSaveDomain domain, User user);

    void releaseByUser(Long examId, String account);

    boolean hasApplied(StudentAnswerTaskEntity t, String account);

    List<StudentAnswerTaskEntity> findUnMarked(Long examId, int pageNumber, int pageSize, StudentAnswerTaskStatus status);

    void deleteByStudentId(Long examId, Long studentId);

    StudentAnswerTaskVo history(Long examId, Long taskId, String account, Boolean next);

    void releaseByTask(StudentAnswerTaskEntity t);

    StudentAnswerTaskStatusVo getStatus(Long examId, User user);

    int getCountByExamAndStatusAndDevice(Long examId, String device, StudentAnswerTaskStatus status);

    int getCountByExamAndGroupAndStatus(Long examId, Long groupId, StudentAnswerTaskStatus status);

    void saveTask(StudentAnswerGroupEntity group, List<Long> studentIds);

}
