package cn.com.qmth.scancentral.task.thread;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.qmth.boot.core.concurrent.model.Semaphore;
import com.qmth.boot.core.concurrent.service.ConcurrentService;

import cn.com.qmth.scancentral.enums.LockType;
import cn.com.qmth.scancentral.service.StudentAnswerGroupService;

public class StudentAnswerGroupResetThread implements Runnable {

    protected static Logger log = LoggerFactory.getLogger(StudentAnswerGroupResetThread.class);

    private Long groupId;

    private StudentAnswerGroupService groupService;

    private ConcurrentService concurrentService;

    private Semaphore semaphore;

    public StudentAnswerGroupResetThread(Long groupId, StudentAnswerGroupService groupService, ConcurrentService concurrentService,
            Semaphore semaphore) {
        this.groupId = groupId;
        this.groupService = groupService;
        this.concurrentService = concurrentService;
        this.semaphore = semaphore;
    }

    @Override
    public void run() {
        try {
            log.info("StudentAnswerGroup[" + groupId + "] reset start");
            concurrentService.getReadWriteLock(LockType.STUDENT_ANSWER_GROUP + "-" + groupId).readLock().lock();
            groupService.resetById(groupId);
            log.info("StudentAnswerGroup[" + groupId + "] reset finish");
        } catch (Exception e) {
            log.error("StudentAnswerGroup[" + groupId + "] reset error", e);
        } finally {
            concurrentService.getReadWriteLock(LockType.STUDENT_ANSWER_GROUP + "-" + groupId).readLock().unlock();
            semaphore.release();
        }
    }

}
